#ifndef __MAIN_H__
#define __MAIN_H__

typedef signed       char           int8_t;
typedef unsigned     char           uint8_t;
typedef signed       int      			int16_t;
typedef unsigned     int      			uint16_t;
typedef signed       long           int32_t;
typedef unsigned     long           uint32_t;

#define SET_BIT0			0x01
#define SET_BIT1			0x02
#define SET_BIT2			0x04
#define SET_BIT3			0x08
#define SET_BIT4			0x10
#define SET_BIT5			0x20
#define SET_BIT6			0x40
#define SET_BIT7			0x80

#define CLR_BIT0       0xFE
#define CLR_BIT1       0xFD
#define CLR_BIT2       0xFB
#define CLR_BIT3       0xF7
#define CLR_BIT4       0xEF
#define CLR_BIT5       0xDF
#define CLR_BIT6       0xBF
#define CLR_BIT7       0x7F

#define IE_INT0_WDT_enable			IEN0 |= 0x01
#define IE_T0_enable						IEN0 |= 0x02
#define IE_INT1_WT_enable				IEN0 |= 0x04
#define IE_T1_enable						IEN0 |= 0x08
#define IE_UART0_enable					IEN0 |= 0x10
#define IE_UART1_enable					IEN0 |= 0x20

#define IE_T2_MV_enable					IEN1 |= 0x01
#define IE_T2_CAP_enable				IEN1 |= 0x02
#define IE_ADC_E_enable					IEN1 |= 0x04
#define IE_ADC_M_enable					IEN1 |= 0x08
#define IE_CLK_ERR_enable				IEN1 |= 0x10
#define IE_CPL_enable						IEN1 |= 0x20

#define IE_INT2_enable					IEN2 |= 0x01
#define IE_INT3_enable					IEN2 |= 0x02
#define IE_PWM_enable						IEN2 |= 0x04
#define IE_PWM_C_enable					IEN2 |= 0x08

#define IE_INT0_WDT_disable			IEN0 &= 0xFE
#define IE_T0_disable						IEN0 &= 0xFD
#define IE_INT1_WT_disable			IEN0 &= 0xFB
#define IE_T1_disable						IEN0 &= 0xF7
#define IE_UART0_disable				IEN0 &= 0xEF
#define IE_UART1_disable				IEN0 &= 0xDF

#define IE_T2_MV_disable				IEN1 &= 0xFE
#define IE_T2_CAP_disable				IEN1 &= 0xFD
#define IE_ADC_E_disable				IEN1 &= 0xFB
#define IE_ADC_M_disable				IEN1 &= 0xF7
#define IE_CLK_ERR_disable			IEN1 &= 0xEF
#define IE_CPL_disable					IEN1 &= 0xDF

#define IE_INT2_disable					IEN2 &= 0xFE
#define IE_INT3_disable					IEN2 &= 0xFD
#define IE_PWM_disable					IEN2 &= 0xFB
#define IE_PWM_C_disable				IEN2 &= 0xF7

#define SYSDIV_8				SYSCON |= 0 << 6
#define SYSDIV_4				SYSCON |= 1 << 6
#define SYSDIV_2				SYSCON |= 2 << 6
#define SYSDIV_0				SYSCON |= 3 << 6
#define IHRCEN					SYSCON |= 0x01
#define ILRCEN					SYSCON |= 0x04
#define STOP_ILRC_EN		CLKCFG |= 0x10
#define STOP_ILRC_DIS		CLKCFG &= 0xEF

#define PCON_STOP				PCON |= 0x02
#define PCON_IDLE				PCON |= 0x01

#define Timer0_CLKEN					CLKEN0 |= 0x01
#define Timer1_CLKEN					CLKEN0 |= 0x02
#define Timer2_CLKEN					CLKEN0 |= 0x04
#define UART2_CLKEN						CLKEN0 |= 0x08
#define UART1_CLKEN						CLKEN0 |= 0x10
#define PWM_CLKEN							CLKEN0 |= 0x20
#define CRC_CLKEN							CLKEN0 |= 0x40
#define ADC_CLKEN							CLKEN0 |= 0x80

#define WDT_CLKEN							CLKEN1 |= 0x01
#define WT_CLKEN							CLKEN1 |= 0x02
#define CPL_CLKEN							CLKEN1 |= 0x04
#define BUZ_CLKEN							CLKEN1 |= 0x08

#define BOR_EN			BORCON |= 0x01
#define BOR_DIS			BORCON &= 0xFE
#define BOR_REF_25	BORCON |= 0 << 1
#define BOR_REF_29	BORCON |= 1 << 1
#define BOR_REF_37	BORCON |= 2 << 1
#define BOR_REF_43	BORCON |= 3 << 1

#endif