#include <ATM8F8040K.H>
#include "main.h"
#include "adc.h"
#include "pwm.h"
#include "uart0.h"
#include <stdio.h>

//#define ADC_MODE0 //תƽֵ
#define ADC_MODE1	//ȫͨѲ
//#define ADC_MODE2 //תжȡֵοʾ
//#define ADC_MODE3 //תȽϲοʾ

#ifdef ADC_MODE0

uint8_t buf[20] = {0};
uint16_t val = 0;
uint8_t code menu1[]="Please select ADC chanel:\r\n";
uint8_t code menu2[]="'0'->CH0 -> P07\r\n******";
uint8_t code menu3[]="\r\n'B'->CH11 -> 2.4V\r\n";

void ADC_Init(void)
{
	AD_VREF_VDD;						//ѡVDDοѹ
	ADCKS_4DIV;							//adcʱķƵ,ADCʱ߹1MHz	
	AD_CONT_disable;				//ֹת
	AD_INT_MODE;						//ʽ
	ADTRG |= 0x70; 					// ӳѡ32
	ADSAMP = 0x0F; 					// ѡ16		
}

unsigned int get_adc_val(uint8_t channel,uint8_t times)
{
	uint16_t val = 0;
	uint8_t i;
	
	AD_EN;
	ADCON &= 0x0F;
	ADCON |= (channel << 4);			
	if(channel < 8)
		AEN0 |= 1 << channel;	
	else if(channel == 11)
		;
	else
		AEN1 |= 1 << (channel - 8);		
	for(i=0;i<times;i++)
	{
		AD_TRIG;
		while (!(ADCON & SET_BIT1));
		ADCON &= CLR_BIT1;
		val += ((uint16_t)(((ADCDATAH & 0x0f) << 8) | ADCDATAL));	
	}
	AEN0 &= 0x00;
	AEN1 &= 0xF8;
	ADCON |= 0xF0;
	AD_DIS;
	
	val /= times;	
	return val;
}

void PWM_init_ADC(void)
{
	PWMCON = 0x20; 	//ͨ1Ƚ,ض
	PWMPERH = 0x03;	//
	PWMPERL = 0xE8;	//PWM Fsys/1000
	CCR1H = 0x01;		//
	CCR1L = 0xF4;   //PWM3ƥʱΪFsys/500
	PWM_SOFT_UPDEAE; //
	
	PWMCFG = 0x07; 	//·ʽƥ£ÿƥ,ϵͳʱԴIHRC8Ƶ,4MHZ

	PWMSEL0 = 0xFF;	//PWMͨźԴѡPWM03ѡOC1L
	PWMSEL1 = 0x3F;	

	PWM3_P01_enable;	//˿ʹ
	PWM_EN;	//ʹPWM
}

void ADC_Test(void)
{
	uint8_t temp;
	ADC_Init();
	PWM_init_ADC();
	Uart0_Init();
	sendString(menu1);
	sendString(menu2);
	sendString(menu3);
	while(1)
	{	
		if(S0CON & 0x01)
		{
			S0CON ^= 0x01;
			temp = S0BUF;
			switch(temp)
			{
				case '0': 
								val = get_adc_val(0,1);
								sprintf(buf,"CH0:%d\r\n",val);
								sendString(buf);
					break;
				case '1': 
								val = get_adc_val(1,1);
								sprintf(buf,"CH1:%d\r\n",val);
								sendString(buf);
					break;
				case '2': 
								val = get_adc_val(2,1);
								sprintf(buf,"CH2:%d\r\n",val);
								sendString(buf);
					break;
				case '3': 
								val = get_adc_val(3,1);
								sprintf(buf,"CH3:%d\r\n",val);
								sendString(buf);
				case '4': 
								val = get_adc_val(4,1);
								sprintf(buf,"CH4:%d\r\n",val);
								sendString(buf);
					break;
				case '5': 
								val = get_adc_val(5,1);
								sprintf(buf,"CH5:%d\r\n",val);
								sendString(buf);
					break;
				case '6': 
								val = get_adc_val(6,1);
								sprintf(buf,"CH6:%d\r\n",val);
								sendString(buf);
					break;
				case '7': 
								val = get_adc_val(7,1);
								sprintf(buf,"CH7:%d\r\n",val);
								sendString(buf);
				case '8': 
								val = get_adc_val(8,1);
								sprintf(buf,"CH8:%d\r\n",val);
								sendString(buf);
					break;
				case '9': 
								val = get_adc_val(9,1);
								sprintf(buf,"CH9:%d\r\n",val);
								sendString(buf);
					break;
				case 'A': 
								val = get_adc_val(10,1);
								sprintf(buf,"CH10:%d\r\n",val);
								sendString(buf);
					break;
				case 'B': 
								val = get_adc_val(11,1);
								sprintf(buf,"CH11:%d\r\n",val);
								sendString(buf);
				default:
					break;				
			}
		}
	}
}
#endif

#ifdef ADC_MODE1
uint8_t buf[20] = {0};
uint16_t val = 0;

void ADC_Init(void)
{
	AD_VREF_VDD;						//ѡVDDοѹ
	ADCKS_4DIV;							//adcʱķƵ,ADCʱ߹1MHz	
	AD_CONT_disable;				//ֹת
	AD_INT_MODE;						//ʽ
	ADTRG |= 0x70; 					// ӳѡ32
	ADSAMP = 0x0F; 					// ѡ16		
}
unsigned int get_adc_val(uint8_t channel,uint8_t times)
{
	uint16_t val = 0;
	uint8_t i;
	
	AD_EN;
	ADCON &= 0x0F;
	ADCON |= (channel << 4);			
	if(channel < 8)
		AEN0 |= 1 << channel;	
	else if(channel == 11)
		;
	else
		AEN1 |= 1 << (channel - 8);		
	for(i=0;i<times;i++)
	{
		AD_TRIG;
		while (!(ADCON & SET_BIT1));
		ADCON &= CLR_BIT1;
		val += ((uint16_t)(((ADCDATAH & 0x0f) << 8) | ADCDATAL));	
	}
	AEN0 &= 0x00;
	AEN1 &= 0xF8;
	ADCON |= 0xF0;
	AD_DIS;
	
	val /= times;	
	return val;
}
void ADC_Test(void)
{
	uint8_t regx = 0;
	ADC_Init();
	Uart0_Init();
	while(1)
	{
		val = get_adc_val(regx,1);
		sprintf(buf,"CH%d:%d\r\n",(uint16_t)regx,val);
		sendString(buf);
		regx++;
		if(regx>11)
			regx = 0;
		//Delay_1ms(50);
	}
}
#endif

#ifdef ADC_MODE2
	void ADC_Init(void)
	{		
		AD_VREF_VDD;						//ѡVDDοѹ
		ADCKS_4DIV;							//adcʱķƵ,ADCʱ߹1MHz	
		AD_CONT_enable;				//תʹ
		AD_INT_MODE;						//ʽ
		ADTRG |= 0x70; 					// ӳѡ32
		ADSAMP = 0x0F; 					// ѡ16				
		AEN0 |= SET_BIT3;
		ADCON |= 3 << 4;//ѡͨ3		
		AD_EN;
		IE_ADC_E_enable;//תжʹ
		EA = 1;
	}	
	void ADC_Test(void)
	{
		ADC_Init();
		P0CR |= SET_BIT2;
				AD_TRIG;//ʼת
		while(1)
		{	
			
		}
	}
	void ADC_EOC_INT(void)	interrupt 8
	{
		uint16_t val;
		val = ((uint16_t)(((ADCDATAH & 0x0f) << 8) | ADCDATAL));
		if(val >= 2047)
		{
				P0_2 = ~P0_2;		//ͨ3ѹһοѹʱת
				AD_CONT_disable;//ֹͣת
		}
	}
#endif
	
#ifdef ADC_MODE3
	void ADC_Init(void)
	{		
		AD_VREF_VDD;						//ѡVDDοѹ
		ADCKS_4DIV;							//adcʱķƵ,ADCʱ߹1MHz	
		AD_CONT_enable;					//תʹ
		AD_INT_MODE;						//ʽ
		ADTRG |= 0x70; 					// ӳѡ32
		ADSAMP = 0x0F; 					// ѡ16				
		AEN0 |= SET_BIT3;
		ADCON |= 3 << 4;	//ѡͨ3		
		ADREF = 0x08;	//ȽADתֵ4λ
		AD_EN;
		IE_ADC_M_enable;//ƥжʹ
		EA = 1;
	}	
	void ADC_Test(void)
	{
		ADC_Init();
		P0CR |= SET_BIT2;
				AD_TRIG;//ʼת
		while(1)
		{	
			//ͨ3ѹ4λADREFƥʱP02ת
		}
	}
	void ADC_REF_INT(void)	interrupt 9
	{
		P0_2 = ~P0_2;
		AD_CONT_disable;
	}
#endif
