#include <ATM8F8040K.H>
#include "main.h"
#include "crc.h"
#include "uart0.h"

void CRC_Init(uint8_t input, uint8_t output,uint8_t xoren,uint16_t crcseed)
{
	CRCCON = ((xoren << 3) | (output << 2) | (input << 1) | 0x01);

	CRCSD1 = crcseed >> 8;
	CRCSD0 = crcseed;
}

void CRC_Test(void)
{
	uint8_t temp;
	uint8_t  i = 0;
	Uart0_Init();
	CRC_Init(0, 0, 0, 0);
	while(1)
	{
		if(S0CON & 0x01)
		{
			S0CON ^= 0x01;
			temp = S0BUF;
			CRCDAT = temp;
			i++;
			if(i > 9)
			{
				i=0;
				sendChar(CRCSD0);
				sendChar(CRCSD1);
				CRC_Init(0, 0, 0, 0);
			}
		}
	}
}