#include <ATM8F8040K.H>
#include "main.h"
#include "iap.h"
#include "uart0.h"
#include "intrins.h"

#define EEPROM_MODE		//eepromдģʽ
//#define FLASH_MODE	//flashдģʽ

#ifdef EEPROM_MODE

uint8_t code emenu1[]="Please input command:\r\n";
uint8_t code emenu2[]="command:0xa5(write),0xaa(read)\r\n";
uint8_t code emenu3[]="format(hex)command,(8)address,(8)data\r\n";

uint8_t EEPROM_Wirte(uint8_t addr,uint8_t wdat)
{
	uint8_t EAsave;
	uint8_t error = 0;
	FSHADRH = 0xF0; //EEPROM ʼַΪ0xF000
	FSHADRL = addr;
	
	FSHDATL = wdat;
	EAsave = EA;
	EA = 0;
	FSHCON = 0xA5;
	_nop_();_nop_();
	while(FSHCON & 0x01);	//ڲ4msʱǿƽ,BUSYλ
	if(FSHCON & 0x02)
		error = 1;
	EA = EAsave;
	return error;//0ʾ,1ʾ
}
uint8_t EEPROM_Read(uint8_t addr)
{
	uint8_t temp;
	uint8_t code *temp1;
	temp1 = 0xf000; //EEPROM ʼַΪ0xF000
	temp = *(temp1+addr);
	return temp;
}

/***³Ϊο***/
void Trigger_IAP(void)
{
	 if(FSHCON & 0x02)
   {
       FSHCON = 0xC3;
   }
   FSHCON = 0xA5;
}
//-----------------------------------------------------------------------------------------------------------
unsigned char Write_APROM(unsigned int iAddress,unsigned char *p,unsigned char uCount)
{   
    unsigned char i = 0;
    unsigned char EAsave;
		unsigned char error = 0;

    if(iAddress < 0xF000)
    {
        iAddress += 0xF000;
    }
    if(iAddress > 0xF080)
    {
			error = 1;
      return error;
    }
    FSHADRH = iAddress >> 8; //EEPROM ʼַΪ0xF000
    FSHADRL = (unsigned char)(iAddress);    
    EAsave = EA;    
		EA = 0;
    while(i < uCount)
    {  
        FSHDATL = p[i];
        Trigger_IAP();	
				_nop_();_nop_();
				while(FSHCON & 0x01);	//ڲ4msʱǿƽ,BUSYλ
				if(FSHCON & 0x02)
					error = 1;
        FSHADRL++;
        i++;
    }
    EA = EAsave;
		return error;
}
//-----------------------------------------------------------------------------------------------------------
void Read_APROM(unsigned int iAddress,unsigned char *p,unsigned char uCount)
{
    unsigned char i = 0;  
    if(iAddress < 0xF000)
    {
        iAddress += 0xF000;
    }
    if(iAddress > 0xF080)
    {
        return;
    }
    while(i < uCount)
    {
        p[i] = *((unsigned char code * )iAddress);
        iAddress++;
        i++;
    }   
}

/*
(ַ)ʽ3ֽڣյд(0xA5)
Ӧĵַдݣյ(0xAA)ͨڷ
Ӧַ
ͨʹhexʽ
eg:յ 0xa5 0x10 0x47ʾ0x10ַд0x47
eg:յ 0xaa 0x10 0xxxʾȡ0x10ַ
*/
void IAP_Test(void)
{
	uint8_t rc[3];
	/***********add flash clk div**************/
	/* FLASH ʱӷƵ 80KHz,Ƶfsys/(2*(FSDIV+1))	*/
	switch(SYSCON & 0xC0)
	{
		case 0x00:	FSDIV = 0x18; break;  //8Ƶ
		case 0x40:	FSDIV = 0x31; break;	//4Ƶ
		case 0x80:	FSDIV = 0x63; break;	//2Ƶ
		case 0xC0:	FSDIV = 0xC7; break;	//Ƶ	
		default:	break;
	}
	Uart0_Init();
	sendString(emenu1);
	sendString(emenu2);
	sendString(emenu3);
	while(1)
	{
		receive(rc,3);
		if(rc[0] == 0xA5 && rc[1] < 0x80)
		{
			EEPROM_Wirte(rc[1],rc[2]);
		}
		if(rc[0] == 0xAA && rc[1] < 0x80)
		{
			sendChar(EEPROM_Read(rc[1]));
		}
	}
}
#endif

#ifdef FLASH_MODE

uint8_t code emenu1[]="Please input command:\r\n";
uint8_t code emenu2[]="command:0xa5(write),0xaa(read)\r\n";
uint8_t code emenu3[]="format(hex)command,(16)address,(16)data\r\n";

uint8_t FLASH_Wirte(uint8_t *flash_buf)
{
	uint8_t EAsave;
	uint8_t error = 0;
	FSHADRH = flash_buf[1]; //FSHADRHַ40H,ʼΪ40H
	FSHADRL = flash_buf[2];
	
	FSHDATH = flash_buf[3];
	FSHDATL = flash_buf[4];
	EAsave = EA;
	EA = 0;
	FSHCON = 0xA5;
	_nop_();_nop_();
	while(FSHCON & 0x01);	//ڲ4msʱǿƽ,BUSYλ
	if(FSHCON & 0x02)
		error = 1;
	EA = EAsave;
	return error;//0ʾ,1ʾ
}
uint8_t FLASH_Read(uint8_t *flash_buf)
{
	uint8_t temp;
	uint8_t code *temp1;
	temp1 = (uint16_t)flash_buf[1]<<8 | flash_buf[2];
	temp = *temp1;
	return temp;
}
/*
(ַ)ʽ5ֽڣյд(0xA5)
Ӧĵַдݣյ(0xAA)ͨڷ
Ӧַ
ͨʹhexʽ
eg:յ a5 1000 AA55ʾ0x1000ַд0x55,0x1001д0xAA
eg:յ aa 1000 xxxxʾȡ0x1000ַ
*/

//FLASHֻͬʱֽ,һֽʱ,ȶ֮ǰһֽں
void IAP_Test(void)
{
	uint8_t flash_buf[5];
	/***********add flash clk div**************/
	/* FLASH ʱӷƵ 80KHz,Ƶfsys/(2*(FSDIV+1))	*/
	switch(SYSCON & 0xC0)
	{
		case 0x00:	FSDIV = 0x18; break;  //8Ƶ
		case 0x40:	FSDIV = 0x31; break;	//4Ƶ
		case 0x80:	FSDIV = 0x63; break;	//2Ƶ
		case 0xC0:	FSDIV = 0xC7; break;	//Ƶ	
		default:	break;
	}
	Uart0_Init();
	sendString(emenu1);
	sendString(emenu2);
	sendString(emenu3);
	while(1)
	{
		receive(flash_buf,5);
		if(flash_buf[0] == 0xA5)
		{
			FLASH_Wirte(flash_buf);
		}
		if(flash_buf[0] == 0xAA)
		{
			sendChar(FLASH_Read(flash_buf));
		}
	}
}
#endif